import React from 'react';
import type { ReactElement } from 'react';
import { ButtonBaseProps } from './ButtonBase';
import { LinkBaseProps } from '../Link';
export type ButtonSize = '2xs' | 'xs' | 'sm' | 'md' | 'lg' | 'xl' | '2xl';
export type ButtonTheme = 'primary' | 'secondary' | 'tertiary' | 'quaternary' | 'primary-destructive' | 'secondary-destructive' | 'tertiary-destructive';
export type ButtonProps = ButtonBaseProps & LinkBaseProps & {
    size?: ButtonSize;
    theme?: ButtonTheme;
    leftSlot?: ReactElement;
    rightSlot?: ReactElement;
    skipCapitalization?: boolean;
};
export declare const Button: React.ForwardRefExoticComponent<React.ButtonHTMLAttributes<HTMLButtonElement> & {
    testID?: string;
} & React.AnchorHTMLAttributes<HTMLAnchorElement> & {
    testID?: string;
    openInNewTab?: boolean;
    disabled?: boolean;
    skipNextLink?: boolean;
} & {
    size?: ButtonSize;
    theme?: ButtonTheme;
    leftSlot?: ReactElement;
    rightSlot?: ReactElement;
    skipCapitalization?: boolean;
} & React.RefAttributes<HTMLButtonElement | HTMLAnchorElement>>;
