export declare const typography: {
    baseFontSize: number;
    headers: {
        xl: {
            huge: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h1: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h2: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h3: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h4: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h5: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h6: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
        };
        default: {
            huge: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h1: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h2: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h3: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h4: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h5: {
                fontSize: string;
                lineHeight: string;
                letterSpacing: string;
                fontWeight: number;
            };
            h6: {
                fontSize: string;
                lineHeight: string;
                fontWeight: number;
            };
        };
    };
    body: {
        headline: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        paragraph: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        label: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        callout: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        footnote: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        caption: {
            fontSize: string;
            lineHeight: string;
            fontWeight: number;
        };
        code: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        ul: {
            marginLeft: string;
            'ol, ul': {
                marginTop: string;
                marginBottom: string;
            };
        };
        ol: {
            marginLeft: string;
            'ol, ul': {
                marginTop: string;
                marginBottom: string;
            };
        };
        li: {
            marginBottom: string;
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        blockquote: {
            color: string;
            paddingLeft: number;
            borderLeft: string;
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
    };
    utility: {
        anchor: {
            color: string;
            fontWeight: number;
            textDecoration: string;
            cursor: string;
            transition: string;
            transform: string;
            ':visited': {
                color: string;
            };
            ':hover': {
                opacity: number;
            };
        };
        inlineCode: {
            display: string;
            backgroundColor: string;
            border: string;
            borderRadius: number;
            padding: string;
            lineHeight: string;
            fontSize: string;
            letterSpacing: string;
            fontWeight: number;
        };
        terminalCode: {
            display: string;
            backgroundColor: string;
            color: string;
            border: string;
            borderRadius: number;
            padding: string;
            lineHeight: string;
            fontSize: string;
            letterSpacing: string;
            fontWeight: number;
        };
        pre: {
            backgroundColor: string;
            borderRadius: number;
            border: string;
            padding: number;
            whiteSpace: string;
            margin: string;
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        terminalPre: {
            backgroundColor: string;
            color: string;
            borderRadius: number;
            border: string;
            padding: number;
            margin: string;
            whiteSpace: string;
            '&:before': {
                content: string;
            };
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
            fontWeight: number;
        };
        hr: {
            backgroundColor: string;
            border: number;
            height: number;
            display: string;
            width: string;
        };
        weight: {
            black: {
                fontWeight: number;
            };
            semiBold: {
                fontWeight: number;
            };
            medium: {
                fontWeight: number;
            };
            regular: {
                fontWeight: number;
            };
        };
    };
    fontSizes: {
        61: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        53: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        49: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        46: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        43: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        39: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        37: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        34: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        31: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        29: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        27: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        25: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        23: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        22: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        20: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        19: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        18: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        16: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        15: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        14: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        13: {
            fontSize: string;
            lineHeight: string;
            letterSpacing: string;
        };
        12: {
            fontSize: string;
            lineHeight: string;
        };
    };
};
